require_relative "./treasure_trove.rb"
require_relative "./playable.rb"
class Player
  include Playable
  attr_accessor :hash, :found_treasures
  attr_writer :health
  def initialize(name,health=100)
    @name = name.capitalize
    @health = health
    @found_treasures = Hash.new(0)
  end
  def self.from_csv(line)
    name,health = line.split(",")
    if health.nil?
      health = "100"
    end
    Player.new(name,health.to_i)
  end
  def to_s
    "I'm #{@name} with a health of #{@health} and a score of #{score}"
  end
  def health
    @health
  end
  def name
    @name
  end
  def name=(name)
    @name = name.capitalize
  end
  def score
    @health + self.points
  end
  def <=>(other_player)
    other_player.score <=> score
  end
  def found_treasure(treasure)
    @found_treasures[treasure.name] += Integer(treasure.point)
    puts "#{name} found a treasure #{treasure.name} of worth #{treasure.point}"
  end
  def points
    all_points = 0
    @found_treasures.each do |treasure|
      all_points += treasure.last
    end
    all_points
  end
  def each_found_treasure
    @found_treasures.each do |treasure|
      obj = Treasure.new(treasure.first,treasure.last)
      yield obj
    end
  end
  def to_csv
    "#{name.ljust(10,".")} #{score}"
  end
end
if __FILE__ == $0
  player = Player.new("moe")
  puts player.points
end